//
// Created by Ciprian Marin on 23.03.2023.
//

#include <iostream>
#include <fstream>
#include <vector>

#define DIM 1005
#define MAX_SUM 50000
#define INF 2000000000
#define SHIFT 25000

using namespace std;

inline int shift(int x) {
    return x+SHIFT;
}

inline int sign(const int &x) {
    return x > 0 ? 1 : -1;
}

void reconst(int i, int diff, const vector<vector<int>>& prev, const vector<int> &prizes, vector<vector<int>> &res) {
    while(prev[i][shift(diff)]) {
        int cp_prev = prev[i][shift(diff)];
        int add_sub = sign(cp_prev);
        int player = add_sub == -1 ? 0 : 1;

        res[player].push_back(cp_prev*add_sub);
        diff+= prizes[cp_prev * add_sub] * add_sub;
        i= cp_prev * add_sub - 1;
    }
}



int main() {
    ifstream fi("premii.in");
    ofstream fo("premii.out");
    int n, sum=0;
    fi>>n;
    vector<int> prizes(n+1);

    for(int i=1;i<=n;i++) {
        fi>>prizes[i];
        sum+=prizes[i];
    }

    vector<vector<int> > dp(n+1, vector<int>(MAX_SUM+5, -INF));
    vector<vector<int> > prev(n+1, vector<int>(MAX_SUM+5));

    dp[0][shift(0)] = 0;
    prev[0][shift(0)] = 0;


    for(int i=1;i<=n;i++) {
        for(int diff=-SHIFT;diff<=SHIFT;diff++) {
            dp[i][shift(diff)] = dp[i-1][shift(diff)];
            prev[i][shift(diff)] = prev[i-1][shift(diff)];

            for(int add_sub=-1;add_sub<=1;add_sub+=2) {
                int new_diff = diff + add_sub*prizes[i];
                if(0<= shift(new_diff) && shift(new_diff) <= MAX_SUM) {

                    if(dp[i][shift(diff)] < dp[i-1][shift(new_diff)]+prizes[i]) {
                        dp[i][shift(diff)] = dp[i-1][shift(new_diff)]+prizes[i];
                        prev[i][shift(diff)] = i*add_sub;
                    }

                }

            }
        }
    }

    fo<<sum-dp[n][shift(0)]<<"\n";

    vector<vector<int> > win_prizes(2, vector<int>());

    reconst(n, 0, prev, prizes, win_prizes);

    for(const auto& player_prizes: win_prizes) {
        fo<<player_prizes.size()<<"\n";
        for(auto prize:player_prizes) {
            fo<<prize<<" ";
        }
        fo<<"\n";
    }



    fi.close();
    fo.close();
    return 0;
}


